local _G = getfenv(0)
local ADDON_NAME, addon = ...

addon.SpellTypes = {
	["Defile"] = "talent",
}
addon.SpellOverridenByTalent = {
	["Death and Decay"] = "Defile",
}

-- Spells whose icons can change based on talents
addon.DynamicSpells = {
	["Summon Gargoyle"] = true,
	["Death and Decay"] = true,
	["Empower Rune Weapon"] = true,
}

-- Spells which need to use the listed name and not the one from the API.
addon.SpecialSpellNames = {
	["Festering Wound < 5"] = true,
	["Bone Shield <= X"] = true,
}

addon.PriorityListDefaults = {
	["Blood"] = {
		"Bone Shield <= X",
		"Crimson Scourge",
		"Rune Strike",
		"Blood Boil",
		"Death and Decay",
    "Shackle the Unworthy",
    "Swarming Mist",
    "Abomination Limb",
    "Blooddrinker",
		"Consumption",
		"Rune Tap",
		"Raise Dead",
	},
	["Frost"] = {
		"Killing Machine",
		"Rime",
		"Dark Succor",
		"Remorseless Winter",
		"Empower Rune Weapon",
		"Breath of Sindragosa",
		"Obliteration",
    "Shackle the Unworthy",
    "Swarming Mist",
    "Abomination Limb",
		"Glacial Advance",
		"Pillar of Frost",
		"Horn of Winter",
		"Raise Dead",
	},
	["Unholy"] = {
		"Raise Dead",
		"Sudden Doom",
		"Summon Gargoyle",
		"Dark Transformation",
		"Unholy Blight",
		"Unholy Assault",
    "Shackle the Unworthy",
    "Soul Reaper",
    "Swarming Mist",
    "Abomination Limb",
		"Dark Succor",
		"Festering Wound < 5",
		"Apocalypse",
		"Death and Decay",
	},
}

-- Procs: Abilities with cooldowns
addon.AbilityProcsList = {
	["Frost"] = {
		["Breath of Sindragosa"] = true,
		["Empower Rune Weapon"] = true,
		["Glacial Advance"] = true,
		["Horn of Winter"] = true,
		["Obliteration"] = true,
		["Pillar of Frost"] = true,
		["Remorseless Winter"] = true,
	},
	["Unholy"] = {
    ["Apocalypse"] = true,
		["Dark Transformation"] = true,
    ["Death and Decay"] = true,
    ["Summon Gargoyle"] = true,
		["Unholy Assault"] = true,
		["Unholy Blight"] = true,
	},
	["Blood"] = {
		["Blooddrinker"] = true,
		["Blood Boil"] = true,
		["Consumption"] = true,
		["Death and Decay"] = true,
		["Rune Strike"] = true,
		["Rune Tap"] = true,
	},
	["All"] = {
    ["Abomination Limb"] = true,
    ["Death's Due"] = true,
    ["Shackle the Unworthy"] = true,
    ["Swarming Mist"] = true,
	},
}

-- Procs: Triggers when usable
addon.UsableProcsList = {
	["Blood"] = {
	},
	["Frost"] = {
	},
	["Unholy"] = {
	},
}

-- These procs are handled differently.
addon.specialProcs = {
	["Apocalypse"] = true,
	["Blooddrinker"] = true,
	["Blood Boil"] = true,
	["Bone Shield <= X"] = true,
	["Breath of Sindragosa"] = true,
	["Consumption"] = true,
	["Dark Transformation"] = true,
	["Death and Decay"] = true,
	["Defile"] = true,
	["Festering Wound < 5"] = true,
	["Glacial Advance"] = true,
	["Horn of Winter"] = true,
	["Obliteration"] = true,
	["Pillar of Frost"] = true,
	["Raise Dead"] = true,
	["Remorseless Winter"] = true,
	["Rune Strike"] = true,
	["Rune Tap"] = true,
    ["Soul Reaper"] = true,
	["Summon Gargoyle"] = true,
	["Unholy Assault"] = true,
	["Unholy Blight"] = true,
}

addon.InverseProcs = {
}

addon.HasRuneCD = {
	["All"] = {
		["Army of the Dead"] = true,
		["Asphyxiate"] = true,
		["Asphyxiate (Blood)"] = true,
		["Blooddrinker"] = true,
		["Death and Decay"] = true,
		["Death's Due"] = true,
		["Defile"] = true,
		["Outbreak"] = true,
	    ["Swarming Mist"] = true,
	},
	["Frost"] = {
		["Remorseless Winter"] = true,
	},
	["Unholy"] = {
		["Unholy Blight"] = true,
	},
	["Blood"] = {
		["Blooddrinker"] = true,
		["Rune Tap"] = true,
	},
}

addon.DefaultCDBarOrderings = {
	["Blood"] = {
		"Rune Tap",
		"Rune Strike",
		"Icebound Fortitude",
		"Vampiric Blood",
		"Anti-Magic Shell",
		"Anti-Magic Zone",
		"Dancing Rune Weapon",
		"Death and Decay",
		"Gorefiend's Grasp",
		"Death's Caress",
		"Blooddrinker",
		"Consumption",
		"Bonestorm",
		"Mark of Blood",
		"Tombstone",
		"Mind Freeze",
		"Asphyxiate (Blood)",
		"Wraith Walk",
		"Death Pact",
		"Lichborne",
		"Raise Ally",
		"Raise Dead",
        "Shackle the Unworthy",
        "Summon Steward",
        "Swarming Mist",
        "Door of Shadows",
        "Soulshape",
        "Abomination Limb",
        "Fleshcraft"
	},
	["Frost"] = {
		"Pillar of Frost",
		"Glacial Advance",
		"Obliteration",
		"Horn of Winter",
		"Anti-Magic Shell",
		"Anti-Magic Zone",
		"Empower Rune Weapon",
		"Hypothermic Presence",
		"Remorseless Winter",
		"Breath of Sindragosa",
		"Mind Freeze",
		"Icebound Fortitude",
		"Wraith Walk",
		"Frostwyrm's Fury",
		"Blinding Sleet",
		"Death Pact",
		"Lichborne",
		"Raise Ally",
		"Raise Dead",
        "Shackle the Unworthy",
        "Summon Steward",
        "Swarming Mist",
        "Door of Shadows",
        "Soulshape",
        "Abomination Limb",
        "Fleshcraft"
	},
	["Unholy"] = {
		"Summon Gargoyle",
		"Dark Transformation",
		"Apocalypse",
		"Unholy Blight",
		"Unholy Assault",
		"Anti-Magic Shell",
		"Anti-Magic Zone",
		"Outbreak",
		"Army of the Dead",
		"Death and Decay",
		"Defile",
		"Mind Freeze",
		"Asphyxiate",
		"Death Pact",
		"Soul Reaper",
		"Icebound Fortitude",
		"Wraith Walk",
		"Lichborne",
		"Raise Ally",
        "Shackle the Unworthy",
        "Summon Steward",
        "Swarming Mist",
        "Door of Shadows",
        "Soulshape",
        "Abomination Limb",
        "Fleshcraft"
	},
}
