local _G = getfenv(0)
local ADDON_NAME, addon = ...

addon.RuneColors = {
    ["DEFAULT"] = { r = 0.7, g = 0.7, b = 1.0, a = 1.0 },
	["BLOOD"] = { r = 0.77, g = 0.12, b = 0.23, a = 1.0 },
	["UNHOLY"] = { r = 0.3, g = 0.8, b = 0.1, a = 1.0 },
	["FROST"] = { r = 0.0, g = 0.4, b = 0.7, a = 1.0 },
	["DEATH"] = { r = 0.51, g = 0.23, b = 0.65, a = 1.0 },
}

addon.RuneCooldownColors = {
    ["DEFAULT"] = { r = 0.6, g = 0.6, b = 0.7, a = 0.1 },
    ["NONE"] = { r = 0.0, g = 0.0, b = 0.0, a = 0.0 },
    ["BLOOD"] = { r = 1.0, g = 0.0, b = 0.0, a = 0.1 },
	["UNHOLY"] = { r = 0.0, g = 1.0, b = 0.0, a = 0.1 },
	["FROST"] = { r = 0.0, g = 0.0, b = 1.0, a = 0.1 },
	["DEATH"] = { r = 1.0, g = 0.0, b = 1.0, a = 0.1 },
}

addon.RuneMapping = {
	[1] = "BLOOD",
	[2] = "FROST",
	[3] = "UNHOLY",
	[4] = "DEATH",
}

addon.defaults = {
	profile = {
		minimap = {
			hide = true,
		},
		debug = false,
		runeDebug = false,
		layoutDebug = false,
		petDebug = false,
		debugBP = false,
		locked = false,
		hideBlizzardFrames = false,
		ooc_alpha = 0.4,
		combatAlpha = 1.0,
		vehicleAlpha = 0.0,
		alphas = {
			petBattle = 0.0,
		},
		auxBarOOCAlpha = 0.0,
		oocRechargeAlphaEnabled = false,
		oocRechargeAlpha = 0.4,
		rechargeAlpha = 0.3,
		showCDText = true,
		rechargeTimers = "None",
		runeOrientation = "HORIZONTAL",
		almostReadyTime = 0,
		almostReadyAlpha = 0.6,
		sortRunes = true,
		runeSortOrder = "BFU",
		runeBackground = 1,
		runeBackgroundAlpha = 0.1,
		runeBackgrounds = {
			transparent = { r = 0.0, g = 0.0, b = 0.0, a = 0.0 },
			black = { r = 0.0, g = 0.0, b = 0.0, a = 1.0 },
		},
		RuneColors = {
			["BLOOD"] = addon.RuneColors["BLOOD"],
			["FROST"] = addon.RuneColors["FROST"],
			["UNHOLY"] = addon.RuneColors["UNHOLY"],
			["DEATH"] = addon.RuneColors["DEATH"],
		},
		RuneCooldownColors = {
			["BLOOD"] = addon.RuneCooldownColors["BLOOD"],
			["FROST"] = addon.RuneCooldownColors["FROST"],
			["UNHOLY"] = addon.RuneCooldownColors["UNHOLY"],
			["DEATH"] = addon.RuneCooldownColors["DEATH"],
			["NONE"] = addon.RuneCooldownColors["NONE"],
		},
		rangeInd = true,
		rangeColor = { r = 1.0, g = 0.0, b = 0.0, a = 0.6 },
		kmStats = false,
		font_face = "Friz Quadrata TT",
		font_size = 12,
		fontFlags = {
			OUTLINE = true,
			THICKOUTLINE = false,
			MONOCHROME = false
		},
		texture = "Compact Runes",
		border = "Compact Runes",
		borderInd = "Compact Runes Bright",
		dimensions = {
			["HORIZONTAL"] = {
				width = 30,
				height = 10,
				spacing = 4,
				inset = 6,
				swap = false,
				barSpacing = 6,
			},
			["VERTICAL"] = {
				width = 12,
				height = 25,
				spacing = 4,
				inset = 6,
				swap = true,
				barSpacing = 6,
			},
		},
		["frame"] = {
			x = 0,
			y = 0,
			color = { r = 0.1, g = 0.1, b = 0.1, a = 1.0 },
			bdcolor = { r = 0.5, g = 0.5, b = 0.5, a = 1.0 },
			rccolor = { r = 1.0, g = 1.0, b = 1.0, a = 0.7 },
		},
		rpTicks = {
			enabled = false,
			color = { r = 0.0, g = 0.0, b = 0.0, a = 1.0 },
			width = 2,
			specs = {
				["Blood"] = {
					cost = 45,
				},
				["Frost"] = {
					cost = 25,
				},
				["Unholy"] = {
					cost = 45,
				},
			},
		},
		["procIcon"] = {
			scale = 1.0,
			userPlaced = false,
			x = 0,
			y = 0,
			alphas = {
				combat = 1.0,
				ooc = 0.6,
			},
		},
		procs = true,
		ignoreRuneCDs = {
			["Procs"] = true,
			["CooldownBar"] = true,
		},
		enabled = {
			["Any"] = {
				["Death and Decay"] = false,
				["Empower Rune Weapon"] = true,
				["Freezing Fog"] = true,
				["Horn of Winter"] = true,
				["Killing Machine"] = true,
				["Missing Presence"] = true,
				["Raise Dead"] = true,
				["Rune Strike"] = true,
				["Summon Gargoyle"] = true,
			},
		},
		priorityList = {
			["Any"] = {},
		},
		cdbars = {
			['**'] = {
				enabled = false,
				x = nil,
				y = nil,
				spacing = 5,
				maxItemsPerRow = 10,
				maxRows = 2,
				oocAlpha = 0.6,
				combatAlpha = 1.0,
				inactiveAlpha = 0.4,
				activeAlpha = 1.0,
				vehicleAlpha = 0.0,
				textcolor = { r = 0.85, g = 0.85, b = 0.0, a = 1.0 },
				textFontSize = 14,
				fontFace = "Friz Quadrata TT",
				height = 32,
				width = 32,
			},
			["Any"] = {
				cds = {
					["Anti-Magic Shell"] = {
						enabled = true,
						type = "spell",
					},
					["Anti-Magic Zone"] = {
						enabled = true,
						type = "spell",
					},
					["Army of the Dead"] = {
						enabled = true,
						type = "spell",
					},
					["Dancing Rune Weapon"] = {
						enabled = true,
						type = "spell",
					},
					["Death and Decay"] = {
						enabled = true,
						type = "spell",
					},
					["Death Pact"] = {
						enabled = true,
						type = "spell",
					},
					["Empower Rune Weapon"] = {
						enabled = true,
						type = "spell",
					},
					["Horn of Winter"] = {
						enabled = true,
						type = "spell",
					},
					["Icebound Fortitude"] = {
						enabled = true,
						type = "spell",
					},
					["Lichborne"] = {
						enabled = true,
						type = "spell",
					},
					["Mark of Blood"] = {
						enabled = true,
						type = "spell",
					},
					["Mind Freeze"] = {
						enabled = true,
						type = "spell",
					},
					["Raise Ally"] = {
						enabled = true,
						type = "spell",
					},
					["Raise Dead"] = {
						enabled = true,
						type = "spell",
					},
					["Rune Tap"] = {
						enabled = true,
						type = "spell",
					},
					["Strangulate"] = {
						enabled = true,
						type = "spell",
					},
					["Summon Gargoyle"] = {
						enabled = true,
						type = "spell",
					},
					["Unbreakable Armor"] = {
						enabled = true,
						type = "spell",
					},
					["Unholy Frenzy"] = {
						enabled = true,
						type = "spell",
					},
					["Vampiric Blood"] = {
						enabled = true,
						type = "spell",
					},
					-- Items
				},
				ordering = {},
			},
		},
		blocks = {
			['**'] = {
				width = 30,
				height = 10,
				textcolor = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
				userPlaced = false,
				x = nil,
				y = nil,
			},
		},
		-- Bars
		bars = {
			-- Provide defaults for all bars.
			-- These are inherited if no bar or no value is set.
			['**'] = {
				textcolor = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
				userPlaced = false,
				x = nil,
				y = nil,
				overrideHeight = false,
				overrideWidth = false,
				height = nil,
				width = nil,
				alpha = 1.0,
			},
			["RunicPowerBar"] = {
				enabled = true,
				color = { r = 0.0, g = 0.82, b = 1.0, a = 1.0 },
				bgcolor = { r = 0.0, g = 0.205, b = 0.25, a = 1.0 },
				textcolor = { r = 0.66, g = 0.82, b = 1.0, a = 1.0 },
				showNumericValue = true,
			},
			["FrostFeverBar"] = {
				enabled = true,
				color = { r = 0.0, g = 0.45, b = 0.6, a = 1.0 },
				bgcolor = { r = 0.0, g = 0.1125, b = 0.15, a = 0.9 },
				textcolor = { r = 0.8, g = 0.8, b = 0.8, a = 1.0 },
			},
			["BloodPlagueBar"] = {
				enabled = true,
				color = { r = 0.5, g = 0.0, b = 0.6, a = 1.0 },
				bgcolor = { r = 0.125, g = 0.0, b = 0.15, a = 0.9 },
				textcolor = { r = 0.8, g = 0.8, b = 0.8, a = 1.0 },
			},
			["SwingTimerBar"] = {
				enabled = false,
				color = { r = 0.7, g = 0.7, b = 0.7, a = 1.0 },
				bgcolor = { r = 0.2, g = 0.2, b = 0.2, a = 1.0 },
				userPlaced = true,
				x = 0,
				y = -30,
				numericTimer = true,
				specs = {
					["Blood"] = false,
					["Frost"] = true,
					["Unholy"] = false,
				},
			},
			["BloodTapBar"] = {
				enabled = true,
				color = { r = 0.7, g = 0.2, b = 0.2, a = 1 },
				bgcolor = { r = 0.55, g = 0.1, b = 0.1, a = 0.8 },
				textcolor = { r = 1.0, g = 0.9, b = 0.9, a = 1.0 },
			},
			["DeathAndDecayBar"] = {
				enabled = false,
				showCooldown = true,
				color = { r = 0.4, g = 0.4, b = 0.48, a = 1 },
				bgcolor = { r = 0.1, g = 0.1, b = 0.1, a = 0.8 },
				textcolor = { r = 0.9, g = 0.9, b = 0.9, a = 1.0 },
				alt_color = { r = 0.3, g = 0.3, b = 0.38, a = 0.3 },
				alt_textcolor = { r = 0.9, g = 0.9, b = 0.9, a = 0.7 },
				specs = {
					["Blood"] = true,
					["Unholy"] = true,
					["Frost"] = true,
				},
			},
			["VampiricBloodBar"] = {
				enabled = false,
				showCooldown = true,
				color = { r = 1.0, g = 0.0, b = 0.0, a = 1 },
				bgcolor = { r = 0.65, g = 0.0, b = 0.0, a = 0.8 },
				textcolor = { r = 1.0, g = 0.9, b = 0.9, a = 1.0 },
				alt_color = { r = 0.6, g = 0.0, b = 0.0, a = 0.5 },
				alt_textcolor = { r = 0.9, g = 0.9, b = 0.9, a = 0.7 },
			},
			["RuneTapBar"] = {
				enabled = true,
				color = { r = 0.7, g = 0.2, b = 0.2, a = 1 },
				bgcolor = { r = 0.55, g = 0.1, b = 0.1, a = 0.8 },
				textcolor = { r = 1.0, g = 0.9, b = 0.9, a = 1.0 },
			},
		},
		events = {
			["**"] = {
				sound = "None",
				soundChannel = "Master",
			},
		},
	},
}
